plugins {
    kotlin("jvm")
    `maven-publish`
}

val guavaDepVersion: String by project
val specifyKotlinAsDependency: String by project

repositories {
    mavenCentral()
}

dependencies {
    testImplementation("org.jetbrains.kotlin:kotlin-test")

    implementation("com.google.guava:guava:$guavaDepVersion-jre")
}

publishing {
    publications {
        create<MavenPublication>("mavenJava") {
            from(components["java"])
            artifact(tasks["sourceJar"])

            pom {
                dependencies {
                    if (specifyKotlinAsDependency.toBoolean()) implementation(kotlin("stdlib"))
                    implementation("com.google.guava:guava:[28,)")
                }
            }
        }
    }
}
