package ru.dbotthepony.kommons.event

import it.unimi.dsi.fastutil.floats.FloatConsumer
import java.util.function.Consumer

interface IFloatSubcripable : ISubscriptable<Float> {
	@Deprecated("Use type specific listener")
	override fun addListener(listener: Consumer<Float>): ISubscriptable.L {
		return addListener(listener::accept)
	}

	fun addListener(listener: FloatConsumer): ISubscriptable.L

	class Impl : IFloatSubcripable, Consumer<Float>, FloatConsumer {
		private inner class L(val callback: FloatConsumer) : ISubscriptable.L {
			private var isRemoved = false

			init {
				subscribers.add(this)
			}

			override fun remove() {
				if (!isRemoved) {
					isRemoved = true
					queue.add(this)
				}
			}
		}

		private val subscribers = ArrayList<L>(0)
		private val queue = ArrayList<L>(0)

		override fun addListener(listener: FloatConsumer): ISubscriptable.L {
			return L(listener)
		}

		override fun accept(t: Float) {
			queue.forEach { subscribers.remove(it) }
			queue.clear()
			subscribers.forEach { it.callback.accept(t) }
		}
	}
}