package ru.dbotthepony.kommons.event

import java.util.function.Consumer
import java.util.function.IntConsumer

interface IIntSubcripable : ISubscriptable<Int> {
	@Deprecated("Use type specific listener")
	override fun addListener(listener: Consumer<Int>): ISubscriptable.L {
		return addListener(IntConsumer { listener.accept(it) })
	}

	fun addListener(listener: IntConsumer): ISubscriptable.L

	class Impl : IIntSubcripable, Consumer<Int>, IntConsumer {
		private inner class L(val callback: IntConsumer) : ISubscriptable.L {
			private var isRemoved = false

			init {
				subscribers.add(this)
			}

			override fun remove() {
				if (!isRemoved) {
					isRemoved = true
					queue.add(this)
				}
			}
		}

		private val subscribers = ArrayList<L>(0)
		private val queue = ArrayList<L>(0)

		override fun addListener(listener: IntConsumer): ISubscriptable.L {
			return L(listener)
		}

		override fun accept(t: Int) {
			queue.forEach { subscribers.remove(it) }
			queue.clear()
			subscribers.forEach { it.callback.accept(t) }
		}
	}
}