package ru.dbotthepony.kommons.io

import ru.dbotthepony.kommons.math.Decimal
import java.io.DataInputStream
import java.io.DataOutputStream
import java.io.InputStream
import java.io.OutputStream

fun InputStream.readDecimal(): Decimal {
	val size = readVarInt()
	require(size >= 0) { "Negative payload size: $size" }
	val bytes = ByteArray(size)
	read(bytes)
	return Decimal.fromByteArray(bytes)
}

fun OutputStream.writeDecimal(value: Decimal) {
	val bytes = value.toByteArray()
	writeVarInt(bytes.size)
	write(bytes)
}

val DecimalValueCodec = StreamCodec(DataInputStream::readDecimal, DataOutputStream::writeDecimal)
